run <- as.integer(Sys.getenv("SGE_TASK_ID"))


transform <- "level"
source("competitors_function.R")
source("data_handling.R")
source("aux_functions.R")


nsave <- 15000
nburn <- 15000
T <- nrow(new.data$large)
h1 <- T-80
fhorz <- 4
shrink.type <- c("RW","Minnesota","SSVS")
size <- c("small","medium","large")#,"medium","large"
for (ii in size){
  for (jj in shrink.type){
      NG_1 <- BVAR(Yraw=new.data[[ii]],nsave=nsave,nburn = nburn,p = 5,h=h1-run+1,prmean=0.9,cons = 1,fhorz=fhorz,shrink.type = jj) #prmean = .9 for stationary data
      #save(NG_1,file=paste("predictive.density",shrink.type,run,sep=".","RData"))
    
    foldername <- paste0("Densities_",transform,"_",jj,"_",ii,sep="")
    dir.create(foldername, showWarnings = FALSE)
    
    save(NG_1, file = paste0(foldername,"/", jj,"_", formatC(run, width=4, flag=0), ".RData"))
  }
}
