NG_VAR <- function(Yraw,nsave,nburn,p,h,a_tau,b_tau,c_tau=.01,d_tau=.01,a_i=0.01,b_i=0.01,var.c1= .01,var.c2 = .01,prmean=1,cons=0,fcst=1,fhorz=4,sample_a=1,imps=0,imphor=20,sv=TRUE,shrink.type="lagwise",store.draws=FALSE,method="LIK"){
  #-------------------------------------------Load packages -----------------------------------------------------------------#
  require(GIGrvg)
  require(Matrix)
  require(MASS)
  require(mvtnorm)
  require(snowfall)
  require(stochvol)
  mlag <- function(X,lag){
    p <- lag
    X <- as.matrix(X)
    Traw <- nrow(X)
    N <- ncol(X)
    Xlag <- matrix(0,Traw,p*N)
    for (ii in 1:p){
      Xlag[(p+1):Traw,(N*(ii-1)+1):(N*ii)]=X[(p+1-ii):(Traw-ii),(1:N)]
    }
    return(Xlag)  
  }  
  #-------------------------------------------Some settings-----------------------------------------------------------------#
  #Number of saved draws and burn-ins
  ntot <- nsave+nburn
  #-----------------------------------------Data preliminaries---------------------------------------------------------------#
  if (cons==1){
    Xraw <- cbind(mlag(Yraw,p),1)
  }else{
    Xraw <- cbind(mlag(Yraw,p))
  }
  Y <- Yraw[(p+1):(nrow(Yraw)-h),]
  X <- Xraw[(p+1):(nrow(Xraw)-h),]
  T <- nrow(X)
  M <- ncol(Y)
  K <- ncol(X)
  k <- K*M
  v <- (M*(M-1))/2
  #-----------------------------------------Initialize Gibbs sampler---------------------------------------------------------#
  A_OLS <- A_draw <- ginv(crossprod(X))%*%crossprod(X,Y)
  Em <-Em.str <-  Y-X%*%A_OLS
  SIGMA <- SIGMA_OLS <- crossprod(Y-X%*%A_OLS)/(T-K)
  #chol_SIG <- t(chol(SIGMA_OLS))
  D <- diag(diag(SIGMA))
  V_prior <- diag(k)*10^2
  V_priorinv <- diag(1/diag(V_prior))
  
  A_prior <- matrix(0,K,M)
  A_prior[1:M,1:M] <- diag(M)*prmean
  a_prior <- as.vector(A_prior)
  
  beta_prior <- matrix(0,v,1)
  theta <- matrix(10,K,M)
  omega <- matrix(10^2,v,1)
  b_draw <- lower.tri(SIGMA_OLS)*1
  Upsilon_draw <- b_draw
  
  diag(Upsilon_draw) <- 1
  
  #SV
  svdraw <- list(para=c(mu=-10,phi=.9,sigma=.2),latent=rep(-3,T))
  svl <- list()
  for (jj in 1:M) svl[[jj]] <- svdraw
  
  hv <- svdraw$latent
  para <- list(mu=-3,phi=.9,sigma=.2)
  H <- matrix(-3,T,M)
  eta <- list()
  #MH preliminaries
  accept <- 0
  accept2 <- 0
  scale1 <- .43
  scale2 <- .45
  #------------------------------------------Create storage matrices----------------------------------------------------------#
  if (store.draws){
  A_store <- array(0,c(nsave,K,M))
  SIGMA_store <- array(0,c(nsave,M,M))
  theta_store <- array(0,c(nsave,K,M))
  omega_store <- array(0,c(nsave,M,M))
  Upsilon_store <- array(0,c(nsave,M,M))
  hv_store <- array(0,c(nsave,T,M))
  
  if (p==1) IRF_store <- array(NA,c(nsave,M,M,imphor-1)) else IRF_store <- array(NA,c(nsave,M,M,imphor))
  }
  pred_store <- array(0,c(nsave,M,fhorz))
  a_store <- matrix(0,nsave,2)
  Lik_store <- matrix(0,nsave,1)
  pars_store <- array(0,c(nsave,3,M))
  #--------------------------------------------Start big Gibbs loop-----------------------------------------------------------#
 # pb <- txtProgressBar(min = 0, max = ntot, style = 3) #start progress bar
  start <- Sys.time()
  for (irep in 1:ntot){
      #Step I: Sample autoregressive parameters
      for (mm in 1:M){
              #Sample autoregressive coefficients equation by equation
              if (mm==1){
                  Y.i <- Y[,mm]*exp(-0.5*H[,mm])
                  X.i <- X*exp(-0.5*H[,mm])
                  
                  V_post <- try(chol2inv(chol(crossprod(X.i)+diag(1/theta[,mm]))),silent=TRUE)
                  if (is(V_post,"try-error")) V_post <- ginv(crossprod(X.i)+diag(1/theta[,mm]))
                  A_post <- V_post%*%(crossprod(X.i,Y.i)+diag(1/theta[,mm])%*%A_prior[,mm])
                  
                  A.draw.i <- try(A_post+t(chol(V_post))%*%rnorm(ncol(X.i)),silent=TRUE)
                  if (is(A.draw.i,"try-error")) A.draw.i <- mvrnorm(1,A_post,V_post)
                  A_draw[,mm] <- A.draw.i
                  Em[,mm] <- Em.str[,mm] <- Y[,mm]-X%*%A.draw.i #first equation u = u.str
              }else{
                  Y.i <- Y[,mm]*exp(-0.5*H[,mm])
                  X.i <- cbind(X,Em[,1:(mm-1)])*exp(-0.5*H[,mm])
                  
                  V_post <- try(chol2inv(chol((crossprod(X.i)+diag(1/c(theta[,mm],b_draw[mm,1:(mm-1)]))))),silent=TRUE)    #solve(crossprod(X.i)+diag(1/c(theta[,mm],b_draw[mm,1:(mm-1)])))
                  if (is(V_post,"try-error")) V_post <- ginv((crossprod(X.i)+diag(1/c(theta[,mm],b_draw[mm,1:(mm-1)]))))
                  A_post <- V_post%*%(crossprod(X.i,Y.i)+diag(1/c(theta[,mm],b_draw[mm,1:(mm-1)]))%*%c(A_prior[,mm],rep(0,mm-1)))
                  
                  A.draw.i <- try(A_post+t(chol(V_post))%*%rnorm(ncol(X.i)),silent=TRUE)
                  if (is(A.draw.i,"try-error")) A.draw.i <- mvrnorm(1,A_post,V_post)
                  
                  A_draw[,mm] <- A.draw.i[1:ncol(X)]
                  Em[,mm] <- Y[,mm]-X%*%A.draw.i[1:ncol(X)]
                  Em.str[,mm] <- Y[,mm]-X%*%A.draw.i[1:ncol(X)]-Em[,1:(mm-1),drop=FALSE]%*%A.draw.i[(ncol(X)+1):ncol(X.i),drop=FALSE] 
                  Upsilon_draw[mm,1:(mm-1)] <- eta[[mm]]<- A.draw.i[(ncol(X)+1):ncol(X.i)]
              }
      }


    if (shrink.type=="global"){
    #Step II: Sample hyperparameter lambda from G(a,b)
    lambda2_tau <- rgamma(1,c_tau+a_tau*k,d_tau+a_tau/2*sum(theta))
    #Step III: Sample the prior scaling factors from GIG
    for (mm in 1:M){
      for (nn in 1:K){
          #Exploit properties of the Gamma distribution such that the prior is N(0, theta_ij) 
        theta[nn,mm] <- rgig(n=1,lambda=a_tau-0.5,(A_draw[nn,mm]-A_prior[nn,mm])^2,a_tau*lambda2_tau)
      }
    }
    theta[theta<1e-9] <- 1e-9
    
    if (sample_a==1){
      #Sample a_tau through a simple RWMH step (on-line tuning of the MH scaling within the first 50% of the burn-in phase)
      a_prop <- exp(rnorm(1,0,scale1))*a_tau
      post_a_prop <- atau_post(atau=a_prop,thetas = as.vector(theta),lambda2 = lambda2_tau)
      post_a_old <- atau_post(atau=a_tau,thetas = as.vector(theta),lambda2 = lambda2_tau)
      post.diff <- post_a_prop-post_a_old
      post.diff <- ifelse(is.nan(post.diff),-Inf,post.diff)
      if (post.diff > log(runif(1,0,1))){
        a_tau <- a_prop
        accept <- accept+1
      }
    }
    #Scale MH proposal during the first 50% of the burn-in stage
    if (irep<(0.5*nburn)){
      if ((accept/irep)>0.3) scale1 <- 1.01*scale1
      if ((accept/irep)<0.15) scale1 <- 0.99*scale1
    }
    }else if (shrink.type=="rowwise"){
      if (irep==1){
        a_tau <- matrix(a_tau,M,1)
        a_store <- matrix(0,nsave,M+1)
      }   
      #Step II: Sample hyperparameter lambda from G(a,b) and prior scalings: ROWWISE
      for (jj in 1:M){
        lambda2_tau_j <- rgamma(1,c_tau+a_tau[jj]*K,d_tau+a_tau[jj]/2*sum(theta[,jj]))
        for (ii in 1:K){
          theta[ii,jj] <- rgig(n=1,lambda=a_tau[jj]-0.5,(A_draw[ii,jj]-A_prior[ii,jj])^2,a_tau[jj]*lambda2_tau_j)
        }
        
        if (sample_a==1){
          #Sample a_tau through a simple RWMH step (on-line tuning of the MH scaling within the first 50% of the burn-in phase)
          a_prop <- exp(rnorm(1,0,scale1))*a_tau[jj]
          post_a_prop <- atau_post(atau=a_prop,thetas = theta[,jj],lambda2 = lambda2_tau_j)
          post_a_old <- atau_post(atau=a_tau[jj],thetas =theta[,jj],lambda2 = lambda2_tau_j)
          post.diff <- post_a_prop-post_a_old
          post.diff <- ifelse(is.nan(post.diff),-Inf,post.diff)
          
          if (post.diff> log(runif(1,0,1))){
            a_tau[jj] <- a_prop
            #accept <- accept+1
          }
        }
      }
      #
      theta[theta<1e-8] <- 1e-8 #Off-setting in case that the scaling parameter gets too small (i.e. 1/theta becomes Inf)
    }else if (shrink.type=="columnwise"){
      if (irep==1){
        a_tau <- matrix(a_tau,K,1)
        a_store <- matrix(0,nsave,K+1)
      }   
      #Step II: Sample hyperparameter lambda from G(a,b) and prior scalings: COLUMNWISE
      for (jj in 1:K){
        lambda2_tau_j <- rgamma(1,c_tau+a_tau[jj]*M,d_tau+a_tau[jj]/2*sum(theta[jj,]))
        for (ii in 1:M){
          theta[jj,ii] <- rgig(n=1,lambda=a_tau[jj]-0.5,(A_draw[jj,ii]-A_prior[jj,ii])^2,a_tau[jj]*lambda2_tau_j)
        }
        
        if (sample_a==1){
          #Sample a_tau through a simple RWMH step (on-line tuning of the MH scaling within the first 50% of the burn-in phase)
          a_prop <- exp(rnorm(1,0,scale1))*a_tau[jj]
          post_a_prop <- atau_post(atau=a_prop,thetas = theta[jj,],lambda2 = lambda2_tau_j)
          post_a_old <- atau_post(atau=a_tau[jj],thetas =theta[jj,],lambda2 = lambda2_tau_j)
          post.diff <- post_a_prop-post_a_old
          post.diff <- ifelse(is.nan(post.diff),-Inf,post.diff)
          
          if (post.diff > log(runif(1,0,1))){
            a_tau[jj] <- a_prop
            #accept <- accept+1
          }
        }
      }
      theta[theta<1e-7] <- 1e-7
      
     }else if (shrink.type=="lagwise"){
       if (irep==1){
         kappa_j <- matrix(0.01,p,1)
         a_tau <- matrix(a_tau,p,1)
         a_store <- matrix(0,nsave,p+1)
         kappa_store <- matrix(0,nsave,p)
       }
       for (ss in 1:p){
         A.prior.lag <- A_prior[((ss-1)*M+1):(ss*M),]
         A.lag <- A_draw[((ss-1)*M+1):(ss*M),]
         theta.lag <- theta[((ss-1)*M+1):(ss*M),]
         if (ss==1){
           kappa_j[ss,1] <- rgamma(1,var.c1+a_tau[[ss]]*M^2,var.c2+a_tau[[ss]]/2*sum(theta.lag))  
         }else{
           kappa_j[ss,1] <- rgamma(1,var.c1+a_tau[[ss]]*M^2,var.c2+a_tau[[ss]]/2*prod(kappa_j[1:(ss-1),1])*sum(theta.lag))  
         }
         for (jj in 1:M){
           for (ii in 1:M){
             theta.lag[jj,ii] <- rgig(n=1,lambda=a_tau[ss]-0.5,(A.lag[jj,ii]-A.prior.lag[jj,ii])^2,a_tau[ss]*prod(kappa_j[1:(ss),1]))
           }
         }
         theta[((ss-1)*M+1):(ss*M),] <- theta.lag
         theta[theta<1e-7] <- 1e-7
         
         if (sample_a==1){
           #Sample a_tau through a simple RWMH step (on-line tuning of the MH scaling within the first 50% of the burn-in phase)
           a_prop <- exp(rnorm(1,0,scale1))*a_tau[ss]
           post_a_prop <- atau_post(atau=a_prop,thetas = as.vector(theta.lag),lambda2 = prod(kappa_j[1:(ss),1]))
           post_a_old <- atau_post(atau=a_tau[ss],thetas =as.vector(theta.lag),lambda2 = prod(kappa_j[1:(ss),1]))
           post.diff <- post_a_prop-post_a_old
           post.diff <- ifelse(is.nan(post.diff),-Inf,post.diff)
           
           if (post.diff > log(runif(1,0,1))){
             a_tau[ss] <- a_prop
             #accept <- accept+1
           }
         }
       }
     }
    
    #Step IV: Sample covariance parameters
    #Get orthogonalized errors
    #Sample stochastic volatilities
    if (sv){
    pars_var <- matrix(0,3,M)
      for (jj in 1:M){
        svdraw <- svsample2(Em.str[,jj],startpara=para(svl[[jj]]),startlatent=H[,jj],priorphi = c(25, 1.5),priorsigma=1)
        svl[[jj]] <- svdraw
        h_ <- exp(svdraw$latent)
        pars_var[,jj] <- para(svl[[jj]])
        H[,jj] <- log(h_)
        SIGMA <- Upsilon_draw%*%diag(exp(H[T,]))%*%t(Upsilon_draw)
      }
    }else{
      for (jj in 1:M){
      S_1 <- a_i/2+T/2
      S_2 <- b_i/2+crossprod(Em.str[,jj])/2
    
      sig_eta <- 1/rgamma(1,S_1,S_2)
      H[,jj] <- log(sig_eta)
      SIGMA <- Upsilon_draw%*%diag(exp(H[1,]))%*%t(Upsilon_draw)
      }
    }
    # Create SIGMA
    eta_0 <- unlist(eta)
    
    #Step V: Draw prior scaling factors from GIG for covariances
    lambda_omega <- rgamma(1,c_tau+b_tau*v,d_tau+b_tau/2*sum(b_draw[lower.tri(b_draw)]))
    #Step VI: Sample the prior scaling factors for covariances from GIG
    M1 <- 0
    for (nn in 2:M){
      M1 <-M1+1 
      et_0 <- eta[[nn]]
      for (jj in  1:M1){
        b_draw[nn,jj] <- rgig(n=1,lambda=b_tau-0.5,et_0[[jj]]^2,b_tau*lambda_omega)
      }
    }
    if (sample_a==1){
      #Sample b_tau through a simple RWMH step
      b_prop <- exp(rnorm(1,0,scale2))*b_tau
      post_b_prop <- atau_post(atau=b_prop,thetas = b_draw[lower.tri(b_draw)],k = length(b_draw[lower.tri(b_draw)]),lambda2=lambda_omega)
      post_b_old <- atau_post(atau=b_tau,thetas = b_draw[lower.tri(b_draw)],k = length(b_draw[lower.tri(b_draw)]),lambda2=lambda_omega)
      post.diff <- post_b_prop-post_b_old
      post.diff <- ifelse(is.nan(post.diff),-Inf,post.diff)
      if (post.diff > log(runif(1,0,1))){

        b_tau <- b_prop
        accept2 <- accept2+1
      }
      if (irep<(0.5*nburn)){
        if ((accept2/irep)>0.3)  scale2 <- 1.01*scale2
        if ((accept2/irep)<0.15) scale2 <- 0.99*scale2
      }
    }
    #Step VIII: Store draws after burn-in/ Compute forecasts/ Impulse responses etc.
    if (irep>nburn){
      if (store.draws){
      A_store[irep-nburn,,] <- A_draw
      SIGMA_store[irep-nburn,,] <- SIGMA
      theta_store[irep-nburn,,] <- matrix(theta,K,M)
      omega_store[irep-nburn,,] <- b_draw
      Upsilon_store[irep-nburn,,] <- solve(Upsilon_draw)
        if (shrink.type=="lagwise") kappa_store[irep-nburn,] <- kappa_j
        if (sv){
          pars_store[irep-nburn,,] <- pars_var
          hv_store[irep-nburn,,] <- H
        } 
      }
      a_store[irep-nburn,] <- c(a_tau,b_tau)
      
      Lik <- 0
      for (t in 1:T) Lik <- Lik+dmvnorm(Y[t,],X[t,]%*%A_draw,Upsilon_draw%*%diag(exp(H[t,]))%*%t(Upsilon_draw),log=TRUE)
      #Lik#
      if (method=="LIK"){
        Lik_store[irep-nburn,] <-  Lik#
      }else{
        Lik_store[irep-nburn,] <-  part.filt(n.part=1000,H1=H,Upsilon_draw1=Upsilon_draw,A_draw1=A_draw,y=Y,X1=X,pars_var1=pars_var)
      }
      
      if (fcst==1){
        #Compute draw from the predictive density
        zt <- Xraw[nrow(Xraw)-h,]
        z1 <- zt
        Mean00 <- zt
        Sigma00 <- matrix(0,K,K)
        Sigma00[1:M,1:M] <- SIGMA
        Cm <- diag(M)
        varndxv <- c(M,cons,p)
        Htt <- (H[T,])
        SIGMAt <- SIGMA
        companion <- get_companion(A_draw,varndxv)
        Jm <- companion$Jm;Mm <- companion$MM
        if (max(abs(Re(eigen(companion$MM)$values)))>1.05) next
        for (ih in 1:fhorz){
           z1 <- Mm%*%z1
          cholSig <- try(t(chol(Sigma00[1:M,1:M])),silent=TRUE)
          if (is(cholSig,"try-error")){
            yf <- rmvnorm(1,z1[1:M],Sigma00[1:M,1:M])
          }else{
            yf <- z1[1:M]+cholSig%*%rnorm(M,0,1)
          }
          #first and second moments
          Mean00 <- Mm%*%Mean00
          Sigma00 <- Mm%*%Sigma00%*%t(Mm)+Jm%*%SIGMAt%*%t(Jm)
          meanyt <- Cm%*%Mean00[1:M]
          varyt <- Cm%*%Sigma00[1:M,1:M]%*%t(Cm)
          pred_store[irep-nburn,,ih] <- yf
          if (sv){
            Htt <- pars_var[1,]+pars_var[2,]*(Htt-pars_var[1,])+rnorm(M,0,sqrt(pars_var[3,]))
            SIGMAt <- Upsilon_draw%*%diag(exp(Htt))%*%t(Upsilon_draw)
          }
        }
      }
      if (imps==1){
         varndxv <- c(M,cons,p)
         companion <- get_companion(A_draw,varndxv)
         
        if (max(abs(Re(eigen(companion$MM)$values)))>1.05) next
        PHI_array <- array(0,c(M,M,p))
        for (ss in 1:p){
          PHI_array[,,ss] <- t(A_draw[((ss-1)*M+1):(ss*M),])
        }
        irf_0 <- impulsdtrf(PHI_array,t(chol(SIGMA)),imphor)
        IRF_store[irep-nburn,,,] <- irf_0
      }
      
    }
   # setTxtProgressBar(pb, irep)
  }
  # sfCat(paste("Position in hold-out ", h), sep="\n")
  end <- Sys.time()
  print(end-start)   

  if (store.draws){
    A_post <- apply(A_store,c(2,3),median)
    A_mean <- apply(A_store,c(2,3),mean)
    
    SIGMA_post <- apply(SIGMA_store,c(2,3),median)
    theta_post <- apply(theta_store,c(2,3),median)
    omega_post <- apply(omega_store,c(2,3),median)
    Upsilon_post <- apply(Upsilon_store,c(2,3),median)
    Upsilon_draw <- apply(Upsilon_store,c(2,3),mean)
    
    if (sv){
      H_post <- apply(exp(hv_store),c(2,3),mean)
      pars_post <- apply(pars_store,c(2,3),mean)
    } 
    
    if (sv){
    Lik.post <- 0
    for (t in 1:T) Lik.post <- Lik+dmvnorm(Y[t,],X[t,]%*%A_mean,solve(Upsilon_draw)%*%diag((H_post[t,]))%*%t(solve(Upsilon_draw)),log=TRUE)
    
    if (method=="PF"){
     Lik.post <- part.filt(n.part=1000,H1=H_post,Upsilon_draw1=solve(Upsilon_draw),A_draw1=A_mean,y=Y,X1=X,pars_var1=pars_post)#part.filt(n.part=3000,H1=H_post,Upsilon_draw1=Upsilon_mean,A_draw1=A_mean,pars_var1 = pars_post,y=Y,X1=X)
    }
    Dbar <- mean(-4*Lik_store)
    pD <-2*Lik.post
    
    DIC_OA <- c(Dbar+pD,Dbar,pD)
    }else{
      DIC_OA <- NULL
    }
    
    return.list <- list(A=A_store,A_mean=A_post,SIGMA=SIGMA_store,SIGMA_mean=SIGMA_post,a=a_store,Upsilon_mean=Upsilon_post,Upsilon=Upsilon_store,theta=theta_store,theta_mean=theta_post,omega=omega_store,omega_mean=omega_post,predictions=pred_store,A_OLS=A_OLS,SIGMA_OLS=SIGMA_OLS,DIC=DIC_OA,IRF=IRF_store)
  }else{
    return.list <- list(predictions=pred_store,a=a_store)
  }
  
   return(return.list)
 }

 
  
